#Sulfuric Caving, a datapack for Minecraft 1.14 Java Edition.
#Created by domain2genus.
	
#Calling the function to produce gunpowder when fools gold is smelted in an NBT furnace.
	function d2g_caving_sulfur:required/smelting_fools_gold

#Clearing the recipe books from the crafting guide. A quality of life thing that makes gas mask crafting work.
	function d2g_caving_sulfur:recipes/clear
	
#Summoning gas leaks, and calling the function which maintains their behaviour. Gas leaks won't be able to kill players, so I am allowing them to spawn on peaceful difficulty too.
	execute if score #d2g_caving_increment d2g_caving = #d2g_caving_50_seconds d2g_caving as @a[gamemode=!spectator,nbt=!{Dimension:1}] run function d2g_caving_sulfur:required/gas_leak/spawn_gas_leak
	execute as @e[tag=d2g_caving_gas_leak,tag=!d2g_caving_sulfur_acid] at @s run function d2g_caving_sulfur:required/gas_leak/maintain_gas_leak
	#Removing the tags given to players in maintain_gas_leak.mcfunction
		scoreboard players reset @a[tag=!d2g_caving_sulfur_water_mainhand,tag=!d2g_caving_sulfur_water_offhand,scores={d2g_caving=1..}] d2g_caving
		tag @a[tag=d2g_caving_sulfur_water_mainhand] remove d2g_caving_sulfur_water_mainhand
		tag @a[tag=d2g_caving_sulfur_water_offhand] remove d2g_caving_sulfur_water_offhand
	
#Allowing thrown bottles of sulfuric acid to break down blocks directly beneath it.
	execute as @e[type=potion,nbt={Potion:{tag:{Tags:["d2g_caving_sulfur_acid"]}}}] at @s run summon minecraft:area_effect_cloud ~ ~ ~ {Particle:"effect",Radius:0.5f,RadiusPerTick:0f,RadiusOnUse:0f,Duration:2,Color:16777215,Tags:["d2g_caving_sulfur_acid_trail"]}
	execute at @e[tag=d2g_caving_sulfur_acid_trail] unless entity @e[type=potion,nbt={tag:{Tags:["d2g_caving_sulfur_acid"]}},distance=..0.5] if entity @e[type=area_effect_cloud,tag=!d2g_caving_sulfur_acid_trail,nbt={Potion:"minecraft:strong_poison",Color:-1},distance=..1] run tag @e[type=area_effect_cloud,tag=!d2g_caving_sulfur_acid_trail,nbt={Potion:"minecraft:strong_poison",Color:-1},distance=..1] add d2g_caving_sulfur_acid
	execute as @e[tag=d2g_caving_sulfur_acid] at @s run data merge entity @s {RadiusOnUse:0f,DurationOnUse:0f,Potion:"d2g_caving:sulfur"}
	execute as @e[tag=d2g_caving_sulfur_acid,nbt={Age:495}] at @s if block ~ ~-1 ~ #d2g_caving_sulfur:corrodable run setblock ~ ~-1 ~ air destroy
	execute as @e[tag=d2g_caving_sulfur_acid] at @s run function d2g_caving_sulfur:required/gas_leak/maintain_gas_bomb
	
#Returning the NBT of gas masks after they've been placed as an block.
	function d2g_caving_sulfur:required/gas_mask/replace_gasmasks
#Enchanting gas masks by means of enchanted books.
	execute as @e[type=item,nbt={Item:{tag:{Tags:["d2g_caving_gasmask"]}}}] at @s if block ~ ~-0.5 ~ #d2g_caving_sulfur:enchant run function d2g_caving_sulfur:required/gas_mask/enchant_gasmask
	
#Zombies and husks wearing gas masks will now occasionally spawn. Gas masks will replace helmets 1/8 of the time.
	execute if score #d2g_caving_increment d2g_caving < #d2g_caving_10_seconds d2g_caving as @e[type=zombie,tag=!global.ignore,tag=!d2g_caving_zombie] run function d2g_caving_sulfur:required/gas_mask/zombies
	execute if score #d2g_caving_increment d2g_caving < #d2g_caving_10_seconds d2g_caving as @e[type=husk,tag=!global.ignore,tag=!d2g_caving_zombie] run function d2g_caving_sulfur:required/gas_mask/zombies
	tag @e[type=zombie,tag=!d2g_caving_zombie] add d2g_caving_zombie
	tag @e[type=husk,tag=!d2g_caving_zombie] add d2g_caving_zombie
#The tag d2g_caving_mummy is related to the "Are You My Mummy?" advancement.
	tag @e[type=zombie,tag=!d2g_caving_mummy,nbt={ArmorItems:[{tag:{Tags:["d2g_caving_gasmask"]}}]}] add d2g_caving_mummy
	tag @e[type=husk,tag=!d2g_caving_mummy,nbt={ArmorItems:[{tag:{Tags:["d2g_caving_gasmask"]}}]}] add d2g_caving_mummy
	tag @e[tag=d2g_caving_mummy,nbt=!{ArmorItems:[{tag:{Tags:["d2g_caving_gasmask"]}}]}] remove d2g_caving_mummy
	
#Iterating the objective d2g_caving
	execute if score #d2g_caving_increment d2g_caving = #d2g_caving_50_seconds d2g_caving run scoreboard players set #d2g_caving_increment d2g_caving 0
	scoreboard players add #d2g_caving_increment d2g_caving 1