#Sulfuric Caving, a datapack for Minecraft 1.14 Java Edition.
#Created by domain2genus.
	
#All mobs are hurt by sulfuric acid, because unlike gas leaks, I don't know of any living creatures beyond bacteria which could happily survive such attacks.
#However, the same things that will protect mobs/players against gas leaks will protect against acid. This is just to add consistency between the two effects.
	execute as @e[distance=..3.5,nbt=!{ActiveEffects:[{Id:20b,Amplifier:1b}]},nbt=!{ActiveEffects:[{Id:18b}]},nbt=!{Inventory:[{Slot:103b,tag:{Tags:["d2g_caving_gasmask"]}}]},nbt=!{ArmorItems:[{tag:{Tags:["d2g_caving_gasmask"]}}]}] run effect give @s wither 4 1
		
#Like gas leaks will drive silverfish from their homes. Unfortunately you cannot specify block to be destroyed (only to be replaced) using /fill, so an iterative function is used to spawn all silverfish which would normally spawn.
#This does create an odd situation on peaceful difficulty, where the blocks will be destroyed, but no silverfish will spawn. I have left this in deliberately.
	execute store result score @s d2g_caving run fill ~1.5 ~ ~1.5 ~-1.5 ~-2 ~-1.5 air replace #d2g_caving_sulfur:d2g_infested_stones
	execute if entity @s[scores={d2g_caving=1..}] run function d2g_caving_sulfur:required/gas_leak/silverfish
	
#Giving players in range of the acid the recipes for the gas masks.
	recipe give @a[distance=..4] d2g_caving_sulfur:leather_gasmask_display
	recipe give @a[distance=..4] d2g_caving_sulfur:iron_gasmask_display
	recipe give @a[distance=..4] d2g_caving_sulfur:golden_gasmask_display
	recipe give @a[distance=..4] d2g_caving_sulfur:diamond_gasmask_display

#The following three commands are all for ambience, and therefore are optional.
	#This particle command adds more shape to the gas rising from the acid, so players better know where they are likely to be withered.
		particle instant_effect ~ ~0.5 ~ 0.6 0.4 0.6 0.005 10 normal
		particle instant_effect ~ ~-0.5 ~ 0.6 0.4 0.6 0.005 10 normal
	#This second particle command makes it look as though the player were inhaling the gas leak when in range.
		execute as @a[distance=..3] at @s positioned ~ ~1.5 ~ run particle instant_effect ~ ~ ~ 0.01 0.01 0.01 0.0005 1 normal
	#Added a sound for gas leaks/sulfuric acid so that players are more alerted to when/where they are about.
		playsound minecraft:entity.cat.hiss ambient @a[distance=..20] ~ ~ ~ 0.03