#Sulfuric Caving, a datapack for Minecraft 1.14 Java Edition.
#Created by domain2genus.
	
#Inhalers (or puffers, if you prefer) use a sort of muscle relaxant to prevent against symptoms of asthma. This datapack equates weakness potions to that compound.
#Alternatively, gas masks can be equipped to protect against the gases.
#Creepers are not effected by gas leaks, this was because of two reasons: the first being that I didn't want creepers walking around at half a heart of health, and the second being that (if the gas was a sulfur compound) creepers would probably be immune to it anyways.
	execute as @e[distance=..4.5,type=!#d2g_caving_sulfur:gas_leak_safe,nbt=!{ActiveEffects:[{Id:19b,Amplifier:1b}]},nbt=!{ActiveEffects:[{Id:18b}]},nbt=!{Inventory:[{Slot:103b,tag:{Tags:["d2g_caving_gasmask"]}}]}] run effect give @s poison 4 1
	
#Parrots will now act similarly to how canaries were used in mine shafts, like a geiger counter for poisonous gases.
	execute at @e[type=parrot,distance=..30,nbt=!{ActiveEffects:[{Id:9b}]}] run playsound minecraft:entity.parrot.hurt neutral @a[distance=..15] ~ ~ ~ 3
	execute as @e[type=parrot,distance=10..30,nbt=!{ActiveEffects:[{Id:9b}]}] run effect give @s nausea 3 1 false
	execute as @e[type=parrot,distance=..10,nbt=!{ActiveEffects:[{Id:9b}]}] run effect give @s nausea 1 1 false
	
#Gas leaks will drive silverfish from their homes. Unfortunately you cannot specify block to be destroyed (only to be replaced) using /fill, so an iterative function is used to spawn all silverfish which would normally spawn.
#This does create an odd situation on peaceful difficulty, where the blocks will be destroyed, but no silverfish will spawn. I have left this in deliberately.
	execute store result score @s d2g_caving run fill ~3 ~3 ~3 ~-3 ~-3 ~-3 air replace #d2g_caving_sulfur:d2g_infested_stones
	execute if entity @s[scores={d2g_caving=1..}] run function d2g_caving_sulfur:required/gas_leak/silverfish
	
#Players holding water bottle varieties for 10 seconds in a gas leak will aquire sulfuric acid.
	tag @a[distance=..4.5,nbt={SelectedItem:{id:"minecraft:potion",Count:1b,tag:{Potion:"minecraft:water"}}}] add d2g_caving_sulfur_water_mainhand
	tag @a[distance=..4.5,nbt={SelectedItem:{id:"minecraft:splash_potion",Count:1b,tag:{Potion:"minecraft:water"}}}] add d2g_caving_sulfur_water_mainhand
	tag @a[distance=..4.5,nbt={SelectedItem:{id:"minecraft:lingering_potion",Count:1b,tag:{Potion:"minecraft:water"}}}] add d2g_caving_sulfur_water_mainhand
	tag @a[distance=..4.5,nbt={Inventory:[{Slot:-106b,id:"minecraft:potion",Count:1b,tag:{Potion:"minecraft:water"}}]}] add d2g_caving_sulfur_water_offhand
	tag @a[distance=..4.5,nbt={Inventory:[{Slot:-106b,id:"minecraft:splash_potion",Count:1b,tag:{Potion:"minecraft:water"}}]}] add d2g_caving_sulfur_water_offhand
	tag @a[distance=..4.5,nbt={Inventory:[{Slot:-106b,id:"minecraft:lingering_potion",Count:1b,tag:{Potion:"minecraft:water"}}]}] add d2g_caving_sulfur_water_offhand
	scoreboard players add @a[tag=d2g_caving_sulfur_water_mainhand] d2g_caving 1
	scoreboard players add @a[tag=d2g_caving_sulfur_water_offhand,tag=!d2g_caving_sulfur_water_mainhand] d2g_caving 1
	replaceitem entity @a[tag=d2g_caving_sulfur_water_mainhand,tag=!d2g_caving_sulfur_water_offhand,scores={d2g_caving=200..}] weapon.mainhand lingering_potion{Potion:"minecraft:strong_poison",CustomPotionColor:-1,Tags:["d2g_caving_sulfur_acid"],HideFlags:32,display:{Name:'{"text":"Sulfruic Acid","italic":false}',Lore:['{"text":"WARNING: Corrosive","color":"red","italic":false}']}}
	scoreboard players remove @a[tag=d2g_caving_sulfur_water_mainhand,tag=!d2g_caving_sulfur_water_offhand,scores={d2g_caving=200..}] d2g_caving 200
	replaceitem entity @a[tag=d2g_caving_sulfur_water_offhand,tag=!d2g_caving_sulfur_water_mainhand,scores={d2g_caving=200..}] weapon.offhand lingering_potion{Potion:"minecraft:strong_poison",CustomPotionColor:-1,Tags:["d2g_caving_sulfur_acid"],HideFlags:32,display:{Name:'{"text":"Sulfruic Acid","italic":false}',Lore:['{"text":"WARNING: Corrosive","color":"red","italic":false}']}}
	scoreboard players remove @a[tag=d2g_caving_sulfur_water_offhand,tag=!d2g_caving_sulfur_water_mainhand,scores={d2g_caving=200..}] d2g_caving 200
	replaceitem entity @a[tag=d2g_caving_sulfur_water_mainhand,tag=d2g_caving_sulfur_water_offhand,scores={d2g_caving=200..}] weapon.mainhand lingering_potion{Potion:"minecraft:strong_poison",CustomPotionColor:-1,Tags:["d2g_caving_sulfur_acid"],HideFlags:32,display:{Name:'{"text":"Sulfruic Acid","italic":false}',Lore:['{"text":"WARNING: Corrosive","color":"red","italic":false}']}}
	replaceitem entity @a[tag=d2g_caving_sulfur_water_mainhand,tag=d2g_caving_sulfur_water_offhand,scores={d2g_caving=200..}] weapon.offhand lingering_potion{Potion:"minecraft:strong_poison",CustomPotionColor:-1,Tags:["d2g_caving_sulfur_acid"],HideFlags:32,display:{Name:'{"text":"Sulfruic Acid","italic":false}',Lore:['{"text":"WARNING: Corrosive","color":"red","italic":false}']}}
	scoreboard players remove @a[tag=d2g_caving_sulfur_water_offhand,tag=d2g_caving_sulfur_water_mainhand,scores={d2g_caving=200..}] d2g_caving 200

#Making the gas leaks move (slowly) towards the nearest player.
	execute facing entity @p[distance=..20,gamemode=!spectator] feet run tp @s ^ ^ ^0.015 ~ ~
	
#Giving players in range of gas leaks the recipes for the gas masks.
	recipe give @a[distance=..5] d2g_caving_sulfur:leather_gasmask_display
	recipe give @a[distance=..5] d2g_caving_sulfur:iron_gasmask_display
	recipe give @a[distance=..5] d2g_caving_sulfur:golden_gasmask_display
	recipe give @a[distance=..5] d2g_caving_sulfur:diamond_gasmask_display
	
#The following three commands are all for ambience, and therefore are optional.
	#This particle command adds more shape to the gas leaks, so players better know where they are likely to be poisoned.
		particle effect ~ ~1 ~ 1.3 0.6 1.3 0.005 40 normal
		particle effect ~ ~-1 ~ 1.5 0.6 1.5 0.005 50 normal
	#This second particle command makes it look as though the player were inhaling the gas leak when in range.
		execute as @a[distance=..4] at @s positioned ~ ~1.5 ~ run particle effect ~ ~ ~ 0.01 0.01 0.01 0.0005 1 normal
	#Added a sound for gas leaks so that players are more alerted to when/where they are about.
		playsound minecraft:entity.cat.hiss ambient @a[distance=..40] ~ ~ ~ 0.05