#Sulfuric Caving, a datapack for Minecraft 1.14 Java Edition.
#Created by domain2genus.

#The tags allow armours stands to wait until the next time this function is run before summoning a new gas leak. Gas leaks last 10 seconds less than the interval between spawns.
#However, to prevent AFK players from constantly being poisoned, armour stands too close to a player aren't given the chance to spawn a gas leak.
	execute at @s run kill @e[tag=d2g_caving_gas_leak_planned,distance=..7]
	tag @e[tag=d2g_caving_gas_leak_planned] add d2g_caving_gas_leak

#The gas leaks are inspired by sulfur dioxide. This is why the particles in the gas leak are the same as those about the furnace when extracting gunpowder from fools gold.
	execute at @e[type=armor_stand,tag=d2g_caving_gas_leak] run summon minecraft:area_effect_cloud ~ ~ ~ {Particle:"effect",Radius:5f,RadiusPerTick:0f,RadiusOnUse:0f,Duration:600,Tags:["global.ignore","global.ignore.pos","d2g_caving_gas_leak"]}

#Because spreadplayers does not work with cave systems, temporary armour stand are placed as markers for where gas leaks will spawn. Placing them in the players path ensures that they are spawning in caves.
#Gas leaks can spawn in oceans (think of them as thermal vents in that case), in caves (as gases released from mining), or in the nether (where I'd imagine sulfur is very abundant).
	execute at @s if entity @s[y=5,dy=45,nbt={Dimension:0}] run summon armor_stand ~ ~ ~ {Small:1b,Invisible:1b,Invulnerable:1b,DisabledSlots:4144959,Tags:["global.ignore.pos","d2g_caving_gas_leak_planned"]}
	execute at @s if entity @s[nbt={Dimension:-1}] run summon armor_stand ~ ~ ~ {Small:1b,Invisible:1b,Invulnerable:1b,DisabledSlots:4144959,Tags:["global.ignore.pos","d2g_caving_gas_leak_planned"]}

#Kills all armour stands that will have spawned a gas leak. This slows the build up of gas leaks and particles in any one area.
	kill @e[type=armor_stand,tag=d2g_caving_gas_leak]