#NBT Smelting, a utility datapack for Minecraft 1.14 Java Edition.
#Created by domain2genus.

#Giving NBT functionality to a furnace.
	execute as @e[type=item_frame,tag=!d2g_smelting,tag=!global.ignore] at @s if block ^ ^ ^-1 #d2g_nbt_smelting:cookers run tag @s add d2g_smelting
	tag @e[tag=d2g_smelting] add global.ignore.pos
	tag @e[tag=d2g_smelting] add global.ignore
#Resetting which blocks the item frames have detected.
	tag @e[tag=d2g_smelting_hopper] remove d2g_smelting_hopper
	tag @e[tag=d2g_furnace] remove d2g_furnace
	tag @e[tag=d2g_campfire] remove d2g_campfire

#Preventing multiple item frames from being used on one furnace.
	execute as @e[tag=d2g_smelting] at @s positioned ^ ^ ^-0.6 if block ~ ~ ~ #d2g_nbt_smelting:cookers if entity @e[tag=d2g_smelting,distance=..0.55] run tag @s remove global.ignore
	execute as @e[tag=d2g_smelting] at @s positioned ^ ^ ^-0.6 if block ~ ~ ~ #d2g_nbt_smelting:cookers if entity @e[tag=d2g_smelting,distance=..0.55] run tag @s remove global.ignore.pos
	execute as @e[tag=d2g_smelting] at @s positioned ^ ^ ^-0.6 if block ~ ~ ~ #d2g_nbt_smelting:cookers if entity @e[tag=d2g_smelting,distance=..0.55] run tag @s remove d2g_smelting
	
#The following segment deals exclusively with furnaces and smelters.
	execute as @e[tag=d2g_smelting] at @s positioned ^ ^ ^-0.6 if block ~ ~ ~ #d2g_nbt_smelting:furnaces run tag @s add d2g_furnace
	#The tag d2g_furnace_empty allows creators to run a function 1 or 2 ticks before the game would smelt their item, and to instead place an item in the output slot with the correct NBT.
	#The tag d2g_furnace_filling allows creators to detect the tick just before an item would smelt, and thus lets you add your custom item before the game runs its default recipe.
		execute as @e[tag=d2g_furnace_filling] at @s if block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:2b}]} run function d2g_nbt_smelting:remove_item
		tag @e[tag=d2g_furnace_empty] remove d2g_furnace_empty
		tag @e[tag=d2g_furnace_filling] remove d2g_furnace_filling
		execute as @e[tag=d2g_furnace,tag=!d2g_furnace_empty] at @s unless block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:2b}]} run tag @s add d2g_furnace_empty
		execute as @e[tag=d2g_furnace,tag=d2g_furnace_empty] at @s if block ^ ^ ^-1 minecraft:furnace{CookTime:198s,Items:[{Slot:0b,tag:{Tags:["d2g_nbt_smelting"]}}]} run tag @s add d2g_furnace_filling
		execute as @e[tag=d2g_furnace,tag=d2g_furnace_empty] at @s if block ^ ^ ^-1 #d2g_nbt_smelting:furnaces_special{CookTime:98s,Items:[{Slot:0b,tag:{Tags:["d2g_nbt_smelting"]}}]} run tag @s add d2g_furnace_filling

#The following segment deals exclusively with campfires.
	execute as @e[tag=d2g_smelting] at @s positioned ^ ^ ^-0.6 if block ~ ~ ~ minecraft:campfire[lit=true] run tag @s add d2g_campfire
	#I could not work out a way to detect the individual cook times of items on campfires directly, so instead I gave the items a new tag that tracks their CookingTimes.
	#These new tags for the campfire then give the item frame a different custom tag each, these 4 tags should be tested for when trying to replace campfire items: d2g_campfire_0, d2g_campfire_1, d2g_campfire_2, d2g_campfire_3
		tag @e[tag=d2g_campfire_0] remove d2g_campfire_0
		tag @e[tag=d2g_campfire_1] remove d2g_campfire_1
		tag @e[tag=d2g_campfire_2] remove d2g_campfire_2
		tag @e[tag=d2g_campfire_3] remove d2g_campfire_3
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:0b,tag:{Tags:["d2g_nbt_smelting"]}}]} store result block ^ ^ ^-0.5 Items[{Slot:0b}].tag.d2g_fire_cooktime int 1 run data get block ^ ^ ^-0.5 CookingTimes[0]
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:1b,tag:{Tags:["d2g_nbt_smelting"]}}]} store result block ^ ^ ^-0.5 Items[{Slot:1b}].tag.d2g_fire_cooktime int 1 run data get block ^ ^ ^-0.5 CookingTimes[1]
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:2b,tag:{Tags:["d2g_nbt_smelting"]}}]} store result block ^ ^ ^-0.5 Items[{Slot:2b}].tag.d2g_fire_cooktime int 1 run data get block ^ ^ ^-0.5 CookingTimes[2]
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:3b,tag:{Tags:["d2g_nbt_smelting"]}}]} store result block ^ ^ ^-0.5 Items[{Slot:3b}].tag.d2g_fire_cooktime int 1 run data get block ^ ^ ^-0.5 CookingTimes[3]
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:0b,tag:{d2g_fire_cooktime:598}}]} run tag @s add d2g_campfire_0
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:1b,tag:{d2g_fire_cooktime:598}}]} run tag @s add d2g_campfire_1
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:2b,tag:{d2g_fire_cooktime:598}}]} run tag @s add d2g_campfire_2
		execute as @e[tag=d2g_campfire] at @s if block ^ ^ ^-0.5 minecraft:campfire{Items:[{Slot:3b,tag:{d2g_fire_cooktime:598}}]} run tag @s add d2g_campfire_3
	
#Testing if an item frame's furnace outputs into a hopper or into a hopper minecart.
	execute as @e[tag=d2g_smelting] at @s positioned ~ ~-0.8 ~ if block ^ ^ ^-0.5 minecraft:hopper run tag @s add d2g_smelting_hopper
	execute as @e[tag=d2g_smelting] at @s positioned ~ ~-0.8 ~ positioned ^ ^ ^-0.5 if entity @e[type=minecraft:hopper_minecart,distance=..0.7] run tag @s add d2g_smelting_hopper